#include <iostream>
#include <vector>

using namespace std;

typedef vector<int> array;

void show( const array& A ){
  for( array::const_iterator i=A.begin();i!=A.end();++i ){
    cout << *i << endl;
  }  
  cout << endl;
}


void unionMinusIntersect( const array& a, const array& b, array& result ){
  result.assign( a.begin(), a.end() );                  // result = a; element copy
  result.insert( result.end(), b.begin(), b.end() );    // append elements in b to result

  sort( result.begin(), result.end() ); //sort to quickly find unique elements to remove
  
  //we loop and remove all duplicates (both elements so for 1 2 2 4 6 6 we remove 2 2 and 6 6, leaving 1 4
  array::iterator pos = result.begin();
  while( pos!=result.end() ){
    if( ((pos+1) != result.end()) && 
        (*pos == *(pos+1)) ){
        array::iterator newpos = pos-1;
        result.erase( pos, pos+2 );  //removes at pos and pos+1
        pos = newpos;
    }
    pos++;
  }
  
}


int main(){
  array A;
  A.push_back( 1 ); A.push_back( 2 ); A.push_back(3); A.push_back(6);
  array B;
  B.push_back( 2 ); B.push_back( 3 ); B.push_back(5); B.push_back(6);

  array result;
  
  cout << "A=" << endl;
  show(A);
  
  cout << "B=" << endl;
  show(B);
  
  
  cout << "unionMinusIntersect (A,B,result)=" << endl;
  unionMinusIntersect( A, B, result );
  show( result );


  //testing edge cases where empty sets are used as input
  cout << "testing empty inputs..."<<flush;
  B.clear();
  unionMinusIntersect( A,B,result );
  unionMinusIntersect( B,A,result );
  A.clear();
  unionMinusIntersect( A,B,result );
  show( result );
  cout << "done."<<endl;
      
  return 0;  
}

